/* Copyright (c) 1994, 1998 John E. Davis
 * This file is part of the JDMath library.
 *
 * You may distribute this file under the terms the GNU General Public
 * License.  See the file COPYING for more information.
 */
#include "config.h"

#include <stdio.h>

#ifdef HAVE_STDLIB_H
# include <stdlib.h>
#endif

#include "jdmath.h"

static double *Sort_Array;
static int double_cmp (unsigned int *a, unsigned int *b)
{
   double x, y;
   double *xp, *yp;
   
   x = *(xp = Sort_Array + *a);
   y = *(yp = Sort_Array + *b);
   if (x > y) return 1; else if (x < y) return -1;
   if (xp > yp) return 1;
   if (xp == yp) return 0;
   return -1;
}

unsigned int *JDMsort_doubles (double *x, unsigned int n)
{
   /* This is a silly hack to make up for braindead compilers and the lack of
    * uniformity in prototypes for qsort.
    */
   void (*qsort_fun) (char *, unsigned int, int, int (*)(unsigned int *, unsigned int *));
   unsigned int *index_array;
   unsigned int i;
   
   if (NULL == (index_array = (unsigned int *) JDMinteger_vector (n)))
     return NULL;
   
   qsort_fun = (void (*)(char *, unsigned int, int, int (*)(unsigned int *,
							    unsigned int *))) 
     qsort;
   for (i = 0; i < n; i++) index_array[i] = i;
   Sort_Array = x;
   (*qsort_fun) ((char *) index_array, n, sizeof (unsigned int), double_cmp);
   return index_array;
}
