/* Copyright (c) 1994, 1998 John E. Davis
 * This file is part of the JDMath library.
 *
 * You may distribute this file under the terms the GNU General Public
 * License.  See the file COPYING for more information.
 */
#include "jdmath.h"

double JDMerf (double x)
{
   int sign;
   double t;

   if (x < 0)
     {
	sign = -1;
	x = -x;
     }
   else sign = 1;
   
   /* This form uses equation 7.126 of A&S.  It is accuracte to
    * 1.5e-7.
    */
   
   t = 1 / (1 + 0.3275911 * x);
   
   if (x < 1.0e17)
     {
	t = 1.0 - (t * (0.254829592 + t * 
			(-0.284496736 + t *
			 (1.421413741 + t *
			  (-1.453152027 + t *
			   (1.061405429)))))) * exp (-x * x);
     }
   else t = 1.0;

   t = t * sign;
   
   return t;
}
